LLI(1)

NAME
lli - directly execute programs from LLVM bytecode

SYNOPSIS
lli [options] [filename] [program args]

DESCRIPTION
lli directly executes programs in LLVM bytecode format. It takes a program in LLVM bytecode format and executes it using a just-in-time compiler, if one is available for the current architecture, or an interpreter. lli takes all of the same code generator options as llc, but they are only effective when lli is using the just-in-time compiler.

If filename is not specified, then lli reads the LLVM bytecode for the program from standard input.

The optional args specified on the command line are passed to the program as arguments.

OPTIONS

-help
    Print a summary of command line options.

-stats
    Print statistics from the code-generation passes. This is only meaningful for the just-in-time compiler, at present.

-time-passes
    Record the amount of time needed for each code-generation pass and print it to standard error.

-mtriple=target triple
    Override the target triple specified in the input bytecode file with the specified string. This may result in a crash if you pick an architecture which is not compatible with the current system.

-march=arch
    Specify the architecture for which to generate assembly, overriding the target encoded in the bytecode file. See the output of llc --help for a list of valid architectures. By default this is inferred from the target triple or autodetected to the current architecture.

-mcpu=cpuname
    Specify a specific chip in the current architecture to generate code for. By default this is inferred from the target triple and autodetected to the current architecture. For a list of available CPUs, use: llvm-as < /dev/null | llc -march=xyz -mcpu=help

-mattr=a1,+a2,-a3,...
    Override or control specific attributes of the target, such as whether SIMD operations are enabled or not. The default set of attributes is set by the current CPU. For a list of available attributes, use: llvm-as < /dev/null | llc -march=xyz -mattr=help

-force-interpreter={false,true}
    If set to true, use the interpreter even if a just-in-time compiler is available for this architecture. Defaults to false.

-f=name
    Call the function named name to start the program. Note: The function is assumed to have the C signature "int" name "(int, char **, char **)". If you try to use this option to call a function of incompatible type, undefined behavior may result. Defaults to "main".

EXIT STATUS
If lli fails to load the program, it will exit with an exit code of 1. Otherwise, it will return the exit code of the program it executes.

SEE ALSO
llc

AUTHOR
Maintained by the LLVM Team (<http://llvm.org>).